package Agent ;

import java.io.* ;
import java.net.* ;

public class AgentHandler extends Thread {
  protected AgentServer server ;
  protected Socket socket ;
  protected boolean messagesOn = true ;

  public AgentHandler( AgentServer server, Socket socket ) {
    this.server = server ;
    this.socket = socket ;
  }

  public void run() {
    startAgentLoader() ;
  }

  protected void startAgentLoader() {
    try {
      AgentClassLoader loader = new AgentClassLoader() ;
      loader.setMessages( messagesOn ) ;
      String className = new String("Agent.DefaultAgentLoader") ;
      loader.addClassBytes( className, ClassBytesLoader.loadClassBytes(
        className ) ) ;
      Class agentLoaderClass = loader.forceLoadClass( className ) ;
      AgentLoader agentLoader = (AgentLoader)agentLoaderClass.newInstance() ;
      agentLoader.setServer( server ) ;
      agentLoader.setInputStream( socket.getInputStream() ) ;
      agentLoader.setOutputStream( socket.getOutputStream() ) ;
      agentLoader.start() ;
    } catch ( Exception e ) {
      e.printStackTrace() ; 
    }
  }

  synchronized public void setMessages( boolean on ) { messagesOn = on ; }
}