// classe di utilit per caricare il contenuto di un file .class
// dal CLASSPATH.

package Agent ;

import java.io.* ;

public class ClassBytesLoader {
  // pu essere chiamata anche da altre classi
  public static byte[] loadClassBytes( String className ) 
    throws IOException {				
		  int size ;
      byte[] classBytes ;
      InputStream is ;
      String fileSeparator = System.getProperty( "file.separator" ) ;
      className = className.replace('.', fileSeparator.charAt(0));
      className = className + ".class";

	    //Cerca la classe (file.class) nel CLASSPATH . 
 		  is = ClassLoader.getSystemResourceAsStream(className);
 		  //se is == null il file non e' stato trovato
      if (is == null) 
        throw new FileNotFoundException(className);
      //se trovato il file legge la dimensione
      size = is.available();
      //crea l'array di byte data destinato a contenere il file
      classBytes = new byte[size];
      //legge il file
      is.read(classBytes);
      is.close();

      return classBytes;
	}
}