// AgentLoader di default

package Agent ;

import java.io.* ;
import java.net.* ;

public class DefaultAgentLoader implements AgentLoader {
  AgentServer server ;
  InputStream iStream ;
  OutputStream oStream ;
  
  public DefaultAgentLoader() {}
  
  public void setServer( AgentServer s ) { server = s ; } 
  public void setInputStream( InputStream i ) { iStream = i ; }
  public void setOutputStream( OutputStream o ) { oStream = o ; }
  
  public void start() {
    try {
      ObjectInputStream objIStream = new ObjectInputStream( iStream ) ;
      ObjectOutputStream objOStream = new ObjectOutputStream( oStream ) ;
      AgentClassLoader cl = (AgentClassLoader)(getClass().getClassLoader()) ;
      // recupera l'AgentPack
      AgentPacket pack = (AgentPacket)(objIStream.readObject()) ;
      objOStream.writeObject( new Boolean( true ) ) ;
      System.out.println( "Ricevuto agente." ) ;
      // aggiorna il database del class loader
      cl.addClassBytes( pack.className, pack.ClassBytes ) ;
      startAgent(pack) ;
    } catch ( ClassNotFoundException e ) {
      e.printStackTrace() ;
    } catch ( IOException ioe ) {
      ioe.printStackTrace() ;
    } catch ( AgentException ae ) {
      ae.printStackTrace() ;
    }
  }
  
  protected void startAgent( AgentPacket pack ) 
      throws ClassNotFoundException, IOException, AgentException  {
    ByteArrayInputStream byteIStream = new ByteArrayInputStream( pack.AgentBytes ) ;
    ObjectInputStream objIStream = new ObjectInputStream( byteIStream ) ;
    // questo provocher il caricamento della classe dell'agente
    Agent agent = (Agent)objIStream.readObject() ;
    System.out.println( "Esecuzione agente : " + agent.AgentName() ) ;
    agent.onArrival() ;
  }
}